// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'atScript.pas' rev: 3.00

#ifndef atScriptHPP
#define atScriptHPP
#include <uSystemLibrary.hpp>
#include <TypInfo.hpp>
#include <atParser.hpp>
#include <Dialogs.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <ComCtrls.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Atscript
{
//-- type declarations -------------------------------------------------------
enum TInstruction { inPrepare, inPushNumber, inPushVar, inPushString, inPushOutput, inDuplicate, inDuplicate2, 
	inDrop2, inSwap2, inOperNE, inOperGE, inOperLE, inOperEqual, inOperGreater, inOperLess, inOperAdd, 
	inOperSub, inOperOr, inOperMul, inOperDiv, inOperAnd, inOperExp, inOperNeg, inJumpIfZero, inJump, inStoreVar, 
	inCall, inRet, inStoreInput, inExecFun, inPushInteger, inCallProc, inTryFinally, inTryExcept };

typedef void __fastcall (__closure *TGenericProc)(void);

typedef void __fastcall (__closure *TBuiltInProc)(const System::Variant &Input, System::Variant &Output
	);

struct TSimplifiedCode;
typedef TSimplifiedCode *pSimplifiedCode;

struct TSimplifiedCode
{
	TInstruction OpCode;
	Byte vByte;
	Byte vUnused[6];
	int vInteger;
	System::AnsiString vString;
	int vDebugInfo;
	TSimplifiedCode *Next;
	TGenericProc Compute;
	union
	{
		struct 
		{
			int vInteger1;
			int vInteger2;
			
		};
		TGenericProc vProc;
		double vDouble;
		
	};
} ;

typedef void __fastcall (__closure *TSingleStepProc)(pSimplifiedCode p);

enum TStackType { stPendingOperators, stIdentifierList, stContext, stVariables };

struct TStackElement;
typedef TStackElement *pStackElement;

struct TStackElement
{
	TStackElement *Previous;
	System::Variant Element;
	int Index;
} ;

struct TAddress;
typedef TAddress *pAddress;

struct TAddress
{
	int Address;
	TSimplifiedCode *Code;
	TAddress *Next;
} ;

struct TLabelSpec;
typedef TLabelSpec *pLabelSpec;

struct TLabelSpec
{
	System::AnsiString Name;
	int Address;
	TAddress *FirstRef;
	TAddress *LastRef;
	TLabelSpec *Next;
} ;

struct TImplicitClassRef
{
	int ClassIndex;
	int ElementIndex;
	bool ElementIsMethod;
} ;

struct TCodeFileHeader
{
	char Signature[25];
	Byte Version;
	int ImplicitRefCount;
	Byte Reserved[32];
} ;

struct TInstructionDetails
{
	Byte OpCode;
	Byte vByte;
	Byte vUnused[2];
	int vInteger;
	int vDebugInfo;
	int vInteger1;
	int vInteger2;
} ;

struct TInstructionDescriptor
{
	int Size;
	TInstructionDetails Details;
} ;

enum TDataOperation { doRead, doWrite, doExec };

enum TClassReference { crNone, crGetter, crSetter, crMethod };

class DELPHICLASS EatPascalRuntime;
class PASCALIMPLEMENTATION EatPascalRuntime : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EatPascalRuntime(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EatPascalRuntime(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EatPascalRuntime(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EatPascalRuntime(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EatPascalRuntime(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EatPascalRuntime(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EatPascalRuntime(int Ident, int AHelpContext) : Sysutils::
		Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EatPascalRuntime(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EatPascalRuntime(void) { }
	
};

class DELPHICLASS EatPascalFatal;
class PASCALIMPLEMENTATION EatPascalFatal : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EatPascalFatal(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EatPascalFatal(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EatPascalFatal(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EatPascalFatal(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EatPascalFatal(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EatPascalFatal(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EatPascalFatal(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EatPascalFatal(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EatPascalFatal(void) { }
	
};

typedef System::Variant atScript__4[3000];

class DELPHICLASS TatCustomScripter;
class DELPHICLASS TScriptInfo;
class DELPHICLASS TRoutinesInfo;
class DELPHICLASS TRoutineInfo;
class PASCALIMPLEMENTATION TRoutinesInfo : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TScriptInfo* FScriptInfo;
	HIDESBASE TRoutineInfo* __fastcall GetItem(int i);
	
public:
	HIDESBASE TRoutineInfo* __fastcall Add(System::AnsiString AName, int ADeclarationSourcePos, int ADeclarationInstruction
		);
	int __fastcall IndexOf(System::AnsiString AName);
	TRoutineInfo* __fastcall RoutineByName(System::AnsiString AName);
	__property TRoutineInfo* Items[int i] = {read=GetItem/*, default*/};
public:
	/* TCollection.Create */ __fastcall TRoutinesInfo(System::TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	/* TCollection.Destroy */ __fastcall virtual ~TRoutinesInfo(void) { }
	
};

class PASCALIMPLEMENTATION TScriptInfo : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TatCustomScripter* FScripter;
	TRoutinesInfo* FRoutines;
	bool FLoaded;
	int FCodeSize;
	void __fastcall CheckLoaded(void);
	
public:
	__fastcall TScriptInfo(TatCustomScripter* AScripter);
	__fastcall virtual ~TScriptInfo(void);
	void __fastcall Clear(void);
	__property TRoutinesInfo* Routines = {read=FRoutines};
	__property int CodeSize = {read=FCodeSize, nodefault};
};

class PASCALIMPLEMENTATION TatCustomScripter : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Atparser::TatSyntaxParser* FatSyntaxParser;
	TSimplifiedCode *FFirstInstruction;
	TSimplifiedCode *FLastInstruction;
	TGenericProc FComputeProcs[34];
	TBuiltInProc FBuiltInProcs[100];
	Classes::TStringList* FBuiltInNames;
	TStackElement *FStack[4];
	int FCodeLine;
	TLabelSpec *FFirstLabelSpec;
	TLabelSpec *FLastLabelSpec;
	TInstruction FAutoRef[11];
	int FAutoRefCount;
	bool FProcrastination;
	bool FSolvedAddressing;
	bool FCompiled;
	System::Variant FProcStack[3000];
	int FStackTop;
	int FStackBase;
	int FInputBase;
	int FOutputBase;
	int FInputOffset;
	int FOutputOffset;
	TSimplifiedCode *FNextInstruction;
	TSimplifiedCode *FCurrentInstruction;
	System::AnsiString FLastExceptionMessage;
	int FLastExceptionHelpContext;
	System::AnsiString FLastExceptionClassName;
	TSimplifiedCode *FPrepareInstruction;
	System::TObject* FCurrentObject;
	int FCurrentInputArgBase;
	int FCurrentOutputArgIndex;
	TScriptInfo* FScriptInfo;
	Classes::TMemoryStream* FPCode;
	Classes::TStrings* FSourceCode;
	void __fastcall StackPush(TStackType StackType, const System::Variant &x);
	void __fastcall StackPushDelimitter(TStackType StackType);
	bool __fastcall EmptyStack(TStackType StackType);
	System::Variant __fastcall StackPop(TStackType StackType);
	System::Variant __fastcall StackView(TStackType StackType);
	int __fastcall StackIndex(TStackType StackType);
	bool __fastcall StackDelimitterFound(TStackType StackType);
	System::Variant __fastcall StackGetByIndex(TStackType st, int i);
	int __fastcall IndexOfStackTextValue(TStackType st, System::AnsiString s);
	void __fastcall ClearStacks(void);
	pLabelSpec __fastcall NewLabelSpec(System::AnsiString Name);
	pLabelSpec __fastcall FindLabelSpec(System::AnsiString name);
	void __fastcall RegisterReference(System::AnsiString Name);
	void __fastcall SolveReference(pLabelSpec LabelSpec);
	void __fastcall DefineReferenceAddress(System::AnsiString Name);
	void __fastcall SetAutomaticReferencing(const TInstruction * ilist, const int ilist_Size);
	void __fastcall ClearLabelSpecs(void);
	void __fastcall SolveUndefinedReferences(void);
	void __fastcall RegisterVariableReference(System::AnsiString id, int &index, System::AnsiString &name
		);
	void __fastcall AppendInstructionDouble(TInstruction i, int vl, Byte vb, double vd, System::AnsiString 
		vs, int ADebugInfo);
	void __fastcall AppendInstructionInteger(TInstruction i, int vl, Byte vb, int vi1, int vi2, System::AnsiString 
		vs, int ADebugInfo);
	void __fastcall AppendInstructionProc(TInstruction i, int vl, Byte vb, TGenericProc vp, System::AnsiString 
		vs, int ADebugInfo);
	int __fastcall ExecProcess(int ParamCount);
	void __fastcall _Prepare(void);
	void __fastcall _PushNumber(void);
	void __fastcall _PushVar(void);
	void __fastcall _PushString(void);
	void __fastcall _PushOutput(void);
	void __fastcall _Duplicate(void);
	void __fastcall _Duplicate2(void);
	void __fastcall _Drop2(void);
	void __fastcall _Swap2(void);
	void __fastcall _OperNE(void);
	void __fastcall _OperGE(void);
	void __fastcall _OperLE(void);
	void __fastcall _OperEqual(void);
	void __fastcall _OperGreater(void);
	void __fastcall _OperLess(void);
	void __fastcall _OperAdd(void);
	void __fastcall _OperSub(void);
	void __fastcall _OperOr(void);
	void __fastcall _OperMul(void);
	void __fastcall _OperDiv(void);
	void __fastcall _OperAnd(void);
	void __fastcall _OperExp(void);
	void __fastcall _OperNeg(void);
	void __fastcall _JumpIfZero(void);
	void __fastcall _Jump(void);
	void __fastcall _StoreVar(void);
	void __fastcall _Call(void);
	void __fastcall _Ret(void);
	void __fastcall _StoreInput(void);
	void __fastcall _ExecFun(void);
	void __fastcall _PushInteger(void);
	void __fastcall _TryFinally(void);
	void __fastcall _TryExcept(void);
	void __fastcall _CallProc(void);
	void __fastcall SetSourceCode(Classes::TStrings* value);
	System::AnsiString __fastcall GetStackContentAsString();
	System::AnsiString __fastcall ErrorComplement(int APos);
	TScriptInfo* __fastcall GetScriptInfo(void);
	void __fastcall ReadPCodeProp(Classes::TStream* Stream);
	void __fastcall WritePCodeProp(Classes::TStream* Stream);
	bool __fastcall PCodeEquals(Classes::TStream* pcode);
	void __fastcall SourceCodeChange(System::TObject* Sender);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall LoadCodeFromStream(Classes::TStream* AStream) = 0;
	virtual void __fastcall SaveCodeToStream(Classes::TStream* AStream) = 0;
	
public:
	__fastcall virtual TatCustomScripter(Classes::TComponent* AOwner);
	__fastcall virtual ~TatCustomScripter(void);
	virtual void __fastcall Clear(void);
	void __fastcall AddFunction(System::AnsiString Name, TBuiltInProc Address);
	virtual void __fastcall Compile(void);
	virtual System::Variant __fastcall Execute(const System::Variant &input);
	System::Variant __fastcall ExecuteSubroutine(System::AnsiString ALabel, const System::Variant &input
		);
	void __fastcall BuildSyntaxTreeView(Comctrls::TTreeView* treeview);
	void __fastcall BuildSimplifiedCodeListView(Comctrls::TListView* listview);
	System::Variant __fastcall GetInputArg(int AIndex);
	System::AnsiString __fastcall GetInputArgAsString(int AIndex);
	int __fastcall GetInputArgAsInteger(int AIndex);
	bool __fastcall GetInputArgAsBoolean(int AIndex);
	double __fastcall GetInputArgAsFloat(int AIndex);
	System::TDateTime __fastcall GetInputArgAsDateTime(int AIndex);
	void __fastcall ReturnOutputArg(const System::Variant &AValue);
	void __fastcall GetRowColFromSource(int APos, int &row, int &col);
	virtual void __fastcall SolveAbsoluteAddressing(void) = 0;
	__property Classes::TStrings* SourceCode = {read=FSourceCode, write=SetSourceCode};
	__property System::AnsiString LastExceptionMessage = {read=FLastExceptionMessage};
	__property int LastExceptionHelpContext = {read=FLastExceptionHelpContext, nodefault};
	__property System::AnsiString LastExceptionClassName = {read=FLastExceptionClassName};
	__property TScriptInfo* ScriptInfo = {read=GetScriptInfo};
	__property System::TObject* CurrentObject = {read=FCurrentObject};
	__property bool Compiled = {read=FCompiled, write=FCompiled, nodefault};
	__property Classes::TMemoryStream* PCode = {read=FPCode, write=FPCode};
};

class DELPHICLASS TVariablesInfo;
class DELPHICLASS TVariableInfo;
class PASCALIMPLEMENTATION TVariablesInfo : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TRoutineInfo* FRoutine;
	HIDESBASE TVariableInfo* __fastcall GetItem(int i);
	
public:
	HIDESBASE TVariableInfo* __fastcall Add(void);
	int __fastcall IndexOf(System::AnsiString AName);
	TVariableInfo* __fastcall VariableByName(System::AnsiString AName);
	__property TVariableInfo* Items[int i] = {read=GetItem/*, default*/};
public:
	/* TCollection.Create */ __fastcall TVariablesInfo(System::TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	/* TCollection.Destroy */ __fastcall virtual ~TVariablesInfo(void) { }
	
};

class PASCALIMPLEMENTATION TRoutineInfo : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TVariablesInfo* FVariables;
	System::AnsiString FName;
	int FDeclarationSourcePos;
	int FDeclarationInstruction;
	
public:
	__fastcall virtual TRoutineInfo(Classes::TCollection* ACollection);
	__fastcall virtual ~TRoutineInfo(void);
	__property System::AnsiString Name = {read=FName};
	__property int DeclarationSourcePos = {read=FDeclarationSourcePos, nodefault};
	__property int DeclarationInstruction = {read=FDeclarationInstruction, nodefault};
	__property TVariablesInfo* Variables = {read=FVariables};
};

class PASCALIMPLEMENTATION TVariableInfo : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FName;
	int FDeclarationSourcePos;
	int FDeclarationInstruction;
	int FReadCount;
	System::Variant __fastcall GetValue();
	void __fastcall SetValue(const System::Variant &AValue);
	TatCustomScripter* __fastcall Scripter(void);
	TRoutineInfo* __fastcall Routine(void);
	
public:
	bool __fastcall Internal(void);
	__property System::AnsiString Name = {read=FName};
	__property int ReadCount = {read=FReadCount, nodefault};
	__property System::Variant Value = {read=GetValue, write=SetValue};
	__property int DeclarationSourcePos = {read=FDeclarationSourcePos, nodefault};
	__property int DeclarationInstruction = {read=FDeclarationInstruction, nodefault};
public:
	/* TCollectionItem.Create */ __fastcall virtual TVariableInfo(Classes::TCollection* Collection) : Classes::
		TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TVariableInfo(void) { }
	
};

class DELPHICLASS TatPascalScripter;
typedef void __fastcall (__closure *TUserProc)(TatPascalScripter* AScripter);

enum TatPascalTypeKind { tkNone, tkInteger, tkChar, tkEnumeration, tkFloat, tkString, tkSet, tkClass, 
	tkMethod, tkWChar, tkLString, tkWString, tkVariant, tkArray, tkRecord, tkInterface };

enum TatPascalModifier { moConst, moVar };

typedef Set<TatPascalModifier, moConst, moVar>  TatPascalModifiers;

enum TLoopStatement { lsNone, lsFor, lsWhile, lsRepeat };

typedef void __fastcall (__closure *TNoArgsNoResultProc)(void);

typedef void __fastcall (__closure *TArgIntegerNoResultProc)(int AInteger);

typedef void __fastcall (__closure *TArgStringNoResultProc)(System::AnsiString AString);

typedef void __fastcall (__closure *TArgBooleanNoResultProc)(bool ABoolean);

typedef void __fastcall (__closure *TArgFloatNoResultProc)(double AFloat);

typedef void __fastcall (__closure *TArgVariantNoResultProc)(const System::Variant &AVariant);

typedef void __fastcall (__closure *TArgObjectNoResultProc)(System::TObject* AObject);

typedef void __fastcall (__closure *TArgIntegerIntegerNoResultProc)(int i, int AInteger1);

typedef void __fastcall (__closure *TArgIntegerStringNoResultProc)(int i, System::AnsiString AString
	);

typedef void __fastcall (__closure *TArgIntegerBooleanNoResultProc)(int i, bool ABoolean);

typedef void __fastcall (__closure *TArgIntegerFloatNoResultProc)(int i, double AFloat);

typedef void __fastcall (__closure *TArgIntegerVariantNoResultProc)(int i, const System::Variant &AVariant
	);

typedef void __fastcall (__closure *TArgIntegerObjectNoResultProc)(int i, System::TObject* AObject);
	

typedef void __fastcall (__closure *TArgStringIntegerNoResultProc)(System::AnsiString s, int AInteger
	);

typedef void __fastcall (__closure *TArgStringStringNoResultProc)(System::AnsiString s, System::AnsiString 
	AString);

typedef void __fastcall (__closure *TArgStringBooleanNoResultProc)(System::AnsiString s, bool ABoolean
	);

typedef void __fastcall (__closure *TArgStringFloatNoResultProc)(System::AnsiString s, double AFloat
	);

typedef void __fastcall (__closure *TArgStringVariantNoResultProc)(System::AnsiString s, const System::Variant 
	&AVariant);

typedef void __fastcall (__closure *TArgStringObjectNoResultProc)(System::AnsiString s, System::TObject* 
	AObject);

typedef int __fastcall (__closure *TNoArgsResultIntegerProc)(void);

typedef System::AnsiString __fastcall (__closure *TNoArgsResultStringProc)(void);

typedef bool __fastcall (__closure *TNoArgsResultBooleanProc)(void);

typedef double __fastcall (__closure *TNoArgsResultFloatProc)(void);

typedef System::Variant __fastcall (__closure *TNoArgsResultVariantProc)(void);

typedef System::TObject* __fastcall (__closure *TNoArgsResultObjectProc)(void);

typedef int __fastcall (__closure *TArgIntegerResultIntegerProc)(int i);

typedef System::AnsiString __fastcall (__closure *TArgIntegerResultStringProc)(int i);

typedef bool __fastcall (__closure *TArgIntegerResultBooleanProc)(int i);

typedef double __fastcall (__closure *TArgIntegerResultFloatProc)(int i);

typedef System::Variant __fastcall (__closure *TArgIntegerResultVariantProc)(int i);

typedef System::TObject* __fastcall (__closure *TArgIntegerResultObjectProc)(int i);

typedef int __fastcall (__closure *TArgStringResultIntegerProc)(System::AnsiString s);

typedef System::AnsiString __fastcall (__closure *TArgStringResultStringProc)(System::AnsiString s);
	

typedef bool __fastcall (__closure *TArgStringResultBooleanProc)(System::AnsiString s);

typedef double __fastcall (__closure *TArgStringResultFloatProc)(System::AnsiString s);

typedef System::Variant __fastcall (__closure *TArgStringResultVariantProc)(System::AnsiString s);

typedef System::TObject* __fastcall (__closure *TArgStringResultObjectProc)(System::AnsiString s);

typedef int __fastcall (__closure *TArgVariantResultIntegerProc)(const System::Variant &v);

typedef System::AnsiString __fastcall (__closure *TArgVariantResultStringProc)(const System::Variant 
	&v);

typedef bool __fastcall (__closure *TArgVariantResultBooleanProc)(const System::Variant &v);

typedef double __fastcall (__closure *TArgVariantResultFloatProc)(const System::Variant &v);

typedef System::Variant __fastcall (__closure *TArgVariantResultVariantProc)(const System::Variant &
	v);

typedef System::TObject* __fastcall (__closure *TArgVariantResultObjectProc)(const System::Variant &
	v);

typedef int __fastcall (__closure *TArgObjectResultIntegerProc)(System::TObject* o);

typedef System::AnsiString __fastcall (__closure *TArgObjectResultStringProc)(System::TObject* o);

typedef bool __fastcall (__closure *TArgObjectResultBooleanProc)(System::TObject* o);

typedef double __fastcall (__closure *TArgObjectResultFloatProc)(System::TObject* o);

typedef System::Variant __fastcall (__closure *TArgObjectResultVariantProc)(System::TObject* o);

typedef System::TObject* __fastcall (__closure *TArgObjectResultObjectProc)(System::TObject* o);

class DELPHICLASS TatPascalClasses;
class DELPHICLASS TatPascalClass;
class PASCALIMPLEMENTATION TatPascalClasses : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalScripter* FScripter;
	HIDESBASE TatPascalClass* __fastcall GetItem(int i);
	
protected:
	TatPascalClass* __fastcall AddClassInfo(System::TMetaClass* AClass);
	TatPascalClass* __fastcall CheckLoaded(System::TMetaClass* AClass);
	bool __fastcall TestCheckLoaded(System::TMetaClass* AClass, TatPascalClass* &ACurrentClass);
	
public:
	__fastcall TatPascalClasses(TatPascalScripter* AScripter);
	HIDESBASE TatPascalClass* __fastcall Add(System::AnsiString AName, System::AnsiString AAncestorName
		);
	int __fastcall IndexOf(System::AnsiString AName);
	__property TatPascalClass* Items[int i] = {read=GetItem/*, default*/};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TatPascalClasses(void) { }
	
};

class DELPHICLASS TatPascalProperties;
class DELPHICLASS TatPascalProperty;
class PASCALIMPLEMENTATION TatPascalProperties : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalClass* FClass;
	HIDESBASE TatPascalProperty* __fastcall GetItem(int i);
	__fastcall TatPascalProperties(TatPascalClass* AClass);
	__property TatPascalProperty* Items[int i] = {read=GetItem/*, default*/};
	TatPascalProperty* __fastcall AddByRTTI(Typinfo::PPropInfo APropInfo);
	int __fastcall IndexOf(System::AnsiString AName);
	TatPascalProperty* __fastcall PropertyByName(System::AnsiString AName);
public:
	/* TCollection.Create */ __fastcall TatPascalProperties(System::TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	/* TCollection.Destroy */ __fastcall virtual ~TatPascalProperties(void) { }
	
};

class DELPHICLASS TatPascalMethods;
class DELPHICLASS TatPascalMethod;
class PASCALIMPLEMENTATION TatPascalMethods : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalClass* FClass;
	HIDESBASE TatPascalMethod* __fastcall GetItem(int i);
	
protected:
	__fastcall TatPascalMethods(TatPascalClass* AClass);
	__property TatPascalMethod* Items[int i] = {read=GetItem/*, default*/};
	int __fastcall IndexOf(System::AnsiString AName);
	TatPascalMethod* __fastcall MethodByName(System::AnsiString AName);
public:
	/* TCollection.Destroy */ __fastcall virtual ~TatPascalMethods(void) { }
	
};

class PASCALIMPLEMENTATION TatPascalClass : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FName;
	TatPascalProperties* FProperties;
	TatPascalMethods* FMethods;
	System::TMetaClass*FClassType;
	System::AnsiString FAncestorName;
	TatPascalClass* FAncestor;
	Classes::TList* FDescendants;
	void __fastcall Inherits(System::AnsiString AAncestorName);
	TatPascalMethod* __fastcall SetProc(System::AnsiString AName, void * ACode, int AArgCount, TatPascalTypeKind 
		AResultDataType, TGenericProc AProc, System::TMetaClass* AResultClass);
	void __fastcall TCollectionGetCountProc(void);
	void __fastcall TCollectionItemGetIndexProc(void);
	void __fastcall TCollectionItemSetIndexProc(void);
	void __fastcall RemoveDescendant(TatPascalClass* ADescendant);
	void __fastcall InsertDescendant(TatPascalClass* ADescendant);
	void __fastcall NotifyDescendants(void);
	void __fastcall AncestorDestroyed(void);
	
public:
	__fastcall virtual TatPascalClass(Classes::TCollection* ACollection);
	__fastcall virtual ~TatPascalClass(void);
	TatPascalMethod* __fastcall AddProc(System::AnsiString AName, void * ACode, int AArgCount, TatPascalTypeKind 
		AResultDataType, TGenericProc AProc, System::TMetaClass* AResultClass);
	void __fastcall AddObject(System::AnsiString AName, System::TObject* AObject);
	void __fastcall AddConstant(System::AnsiString AName, const System::Variant &AValue);
	void __fastcall AddVariable(System::AnsiString AName, void *AVar);
	void __fastcall PrepareVCLClass(void);
	TatPascalProperty* __fastcall AddProp(System::AnsiString AName, TatPascalTypeKind ADataType, TGenericProc 
		AGetter, TGenericProc ASetter, System::TMetaClass* APropertyClass);
	TatPascalProperty* __fastcall SetProp(System::AnsiString AName, TatPascalTypeKind ADataType, TGenericProc 
		AGetter, TGenericProc ASetter, System::TMetaClass* APropertyClass);
	void __fastcall AddIntegerProp(System::AnsiString AName, TGenericProc AGetter, TGenericProc ASetter
		);
	void __fastcall AddStringProp(System::AnsiString AName, TGenericProc AGetter, TGenericProc ASetter)
		;
	void __fastcall AddBooleanProp(System::AnsiString AName, TGenericProc AGetter, TGenericProc ASetter
		);
	void __fastcall AddFloatProp(System::AnsiString AName, TGenericProc AGetter, TGenericProc ASetter);
		
	void __fastcall AddVariantProp(System::AnsiString AName, TGenericProc AGetter, TGenericProc ASetter
		);
	void __fastcall AddObjectProp(System::AnsiString AName, TGenericProc AGetter, TGenericProc ASetter, 
		System::TMetaClass* APropertyClass);
	void __fastcall AddDelphiObjectProp(System::AnsiString AName, System::TObject* AObject);
	TatPascalMethod* __fastcall AddMethod(System::AnsiString AName, int AArgCount, TatPascalTypeKind AResultDataType
		, System::TMetaClass* AResultClass, TGenericProc AProc);
	void __fastcall AddNoArgsNoResultProc(System::AnsiString AName, TNoArgsNoResultProc AMethod);
	void __fastcall AddArgIntegerNoResultProc(System::AnsiString AName, TArgIntegerNoResultProc AMethod
		);
	void __fastcall AddArgStringNoResultProc(System::AnsiString AName, TArgStringNoResultProc AMethod);
		
	void __fastcall AddArgBooleanNoResultProc(System::AnsiString AName, TArgBooleanNoResultProc AMethod
		);
	void __fastcall AddArgFloatNoResultProc(System::AnsiString AName, TArgFloatNoResultProc AMethod);
	void __fastcall AddArgVariantNoResultProc(System::AnsiString AName, TArgVariantNoResultProc AMethod
		);
	void __fastcall AddArgObjectNoResultProc(System::AnsiString AName, TArgObjectNoResultProc AMethod);
		
	void __fastcall AddArgIntegerIntegerNoResultProc(System::AnsiString AName, TArgIntegerIntegerNoResultProc 
		AMethod);
	void __fastcall AddArgIntegerStringNoResultProc(System::AnsiString AName, TArgIntegerStringNoResultProc 
		AMethod);
	void __fastcall AddArgIntegerBooleanNoResultProc(System::AnsiString AName, TArgIntegerBooleanNoResultProc 
		AMethod);
	void __fastcall AddArgIntegerFloatNoResultProc(System::AnsiString AName, TArgIntegerFloatNoResultProc 
		AMethod);
	void __fastcall AddArgIntegerVariantNoResultProc(System::AnsiString AName, TArgIntegerVariantNoResultProc 
		AMethod);
	void __fastcall AddArgIntegerObjectNoResultProc(System::AnsiString AName, TArgIntegerObjectNoResultProc 
		AMethod);
	void __fastcall AddArgStringIntegerNoResultProc(System::AnsiString AName, TArgStringIntegerNoResultProc 
		AMethod);
	void __fastcall AddArgStringStringNoResultProc(System::AnsiString AName, TArgStringStringNoResultProc 
		AMethod);
	void __fastcall AddArgStringBooleanNoResultProc(System::AnsiString AName, TArgStringBooleanNoResultProc 
		AMethod);
	void __fastcall AddArgStringFloatNoResultProc(System::AnsiString AName, TArgStringFloatNoResultProc 
		AMethod);
	void __fastcall AddArgStringVariantNoResultProc(System::AnsiString AName, TArgStringVariantNoResultProc 
		AMethod);
	void __fastcall AddArgStringObjectNoResultProc(System::AnsiString AName, TArgStringObjectNoResultProc 
		AMethod);
	void __fastcall AddNoArgsResultIntegerProc(System::AnsiString AName, TNoArgsResultIntegerProc AMethod
		);
	void __fastcall AddNoArgsResultStringProc(System::AnsiString AName, TNoArgsResultStringProc AMethod
		);
	void __fastcall AddNoArgsResultBooleanProc(System::AnsiString AName, TNoArgsResultBooleanProc AMethod
		);
	void __fastcall AddNoArgsResultFloatProc(System::AnsiString AName, TNoArgsResultFloatProc AMethod);
		
	void __fastcall AddNoArgsResultVariantProc(System::AnsiString AName, TNoArgsResultVariantProc AMethod
		);
	void __fastcall AddNoArgsResultObjectProc(System::AnsiString AName, TNoArgsResultObjectProc AMethod
		, System::TMetaClass* AResultClass);
	void __fastcall AddArgIntegerResultIntegerProc(System::AnsiString AName, TArgIntegerResultIntegerProc 
		AMethod);
	void __fastcall AddArgIntegerResultStringProc(System::AnsiString AName, TArgIntegerResultStringProc 
		AMethod);
	void __fastcall AddArgIntegerResultBooleanProc(System::AnsiString AName, TArgIntegerResultBooleanProc 
		AMethod);
	void __fastcall AddArgIntegerResultFloatProc(System::AnsiString AName, TArgIntegerResultFloatProc AMethod
		);
	void __fastcall AddArgIntegerResultVariantProc(System::AnsiString AName, TArgIntegerResultVariantProc 
		AMethod);
	void __fastcall AddArgIntegerResultObjectProc(System::AnsiString AName, TArgIntegerResultObjectProc 
		AMethod, System::TMetaClass* AResultClass);
	void __fastcall AddArgStringResultIntegerProc(System::AnsiString AName, TArgStringResultIntegerProc 
		AMethod);
	void __fastcall AddArgStringResultStringProc(System::AnsiString AName, TArgStringResultStringProc AMethod
		);
	void __fastcall AddArgStringResultBooleanProc(System::AnsiString AName, TArgStringResultBooleanProc 
		AMethod);
	void __fastcall AddArgStringResultFloatProc(System::AnsiString AName, TArgStringResultFloatProc AMethod
		);
	void __fastcall AddArgStringResultVariantProc(System::AnsiString AName, TArgStringResultVariantProc 
		AMethod);
	void __fastcall AddArgStringResultObjectProc(System::AnsiString AName, TArgStringResultObjectProc AMethod
		, System::TMetaClass* AResultClass);
	void __fastcall AddArgVariantResultIntegerProc(System::AnsiString AName, TArgVariantResultIntegerProc 
		AMethod);
	void __fastcall AddArgVariantResultStringProc(System::AnsiString AName, TArgVariantResultStringProc 
		AMethod);
	void __fastcall AddArgVariantResultBooleanProc(System::AnsiString AName, TArgVariantResultBooleanProc 
		AMethod);
	void __fastcall AddArgVariantResultFloatProc(System::AnsiString AName, TArgVariantResultFloatProc AMethod
		);
	void __fastcall AddArgVariantResultVariantProc(System::AnsiString AName, TArgVariantResultVariantProc 
		AMethod);
	void __fastcall AddArgVariantResultObjectProc(System::AnsiString AName, TArgVariantResultObjectProc 
		AMethod, System::TMetaClass* AResultClass);
	void __fastcall AddArgObjectResultIntegerProc(System::AnsiString AName, TArgObjectResultIntegerProc 
		AMethod);
	void __fastcall AddArgObjectResultStringProc(System::AnsiString AName, TArgObjectResultStringProc AMethod
		);
	void __fastcall AddArgObjectResultBooleanProc(System::AnsiString AName, TArgObjectResultBooleanProc 
		AMethod);
	void __fastcall AddArgObjectResultFloatProc(System::AnsiString AName, TArgObjectResultFloatProc AMethod
		);
	void __fastcall AddArgObjectResultVariantProc(System::AnsiString AName, TArgObjectResultVariantProc 
		AMethod);
	void __fastcall AddArgObjectResultObjectProc(System::AnsiString AName, TArgObjectResultObjectProc AMethod
		, System::TMetaClass* AResultClass);
	__property System::AnsiString Name = {read=FName};
	__property TatPascalProperties* Properties = {read=FProperties};
	__property TatPascalMethods* Methods = {read=FMethods};
	__property System::AnsiString AncestorName = {read=FAncestorName};
};

class PASCALIMPLEMENTATION TatPascalProperty : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TatPascalScripter* FScripter;
	System::AnsiString FName;
	TatPascalTypeKind FDataType;
	TGenericProc FGetter;
	TGenericProc FSetter;
	System::TMetaClass*FPropertyClass;
	Typinfo::TPropInfo *FPropInfo;
	System::Variant FValue;
	void __fastcall RTTIGetterProc(void);
	void __fastcall RTTISetterProc(void);
	void __fastcall GetDelphiObjectPropProc(void);
	void __fastcall GetVariantPropProc(void);
	void __fastcall GetVariablePropProc(void);
	void __fastcall SetVariablePropProc(void);
	
public:
	__fastcall virtual TatPascalProperty(Classes::TCollection* ACollection);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall UpdateObjectInfo(TatPascalClass* &ACurrentClass);
	__property System::AnsiString Name = {read=FName};
	__property TGenericProc Getter = {read=FGetter, write=FGetter};
	__property TGenericProc Setter = {read=FSetter, write=FSetter};
	__property TatPascalTypeKind DataType = {read=FDataType, nodefault};
	__property System::Variant Value = {read=FValue, write=FValue};
public:
	/* TCollectionItem.Destroy */ __fastcall virtual ~TatPascalProperty(void) { }
	
};

class DELPHICLASS TatPascalDataDefs;
class DELPHICLASS TatPascalDataDef;
class PASCALIMPLEMENTATION TatPascalDataDefs : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	HIDESBASE TatPascalDataDef* __fastcall GetItem(int i);
	
public:
	__fastcall TatPascalDataDefs(TatPascalClass* AClass);
	__property TatPascalDataDef* Items[int i] = {read=GetItem/*, default*/};
	HIDESBASE TatPascalDataDef* __fastcall Add(System::AnsiString AName, TatPascalTypeKind ADataType, TatPascalModifier 
		AModifier);
public:
	/* TCollection.Destroy */ __fastcall virtual ~TatPascalDataDefs(void) { }
	
};

class PASCALIMPLEMENTATION TatPascalMethod : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TatPascalScripter* FScripter;
	System::AnsiString FName;
	TGenericProc FProc;
	TatPascalTypeKind FResultDataType;
	int FArgCount;
	void *FCode;
	System::TMetaClass*FResultClass;
	TatPascalDataDefs* FArgumentDefs;
	
public:
	__fastcall virtual TatPascalMethod(Classes::TCollection* ACollection);
	__fastcall virtual ~TatPascalMethod(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall UpdateObjectInfo(TatPascalClass* &ACurrentClass);
	void __fastcall NoArgsNoResultProc(void);
	void __fastcall ArgIntegerNoResultProc(void);
	void __fastcall ArgStringNoResultProc(void);
	void __fastcall ArgBooleanNoResultProc(void);
	void __fastcall ArgFloatNoResultProc(void);
	void __fastcall ArgVariantNoResultProc(void);
	void __fastcall ArgObjectNoResultProc(void);
	void __fastcall ArgIntegerIntegerNoResultProc(void);
	void __fastcall ArgIntegerStringNoResultProc(void);
	void __fastcall ArgIntegerBooleanNoResultProc(void);
	void __fastcall ArgIntegerFloatNoResultProc(void);
	void __fastcall ArgIntegerVariantNoResultProc(void);
	void __fastcall ArgIntegerObjectNoResultProc(void);
	void __fastcall ArgStringIntegerNoResultProc(void);
	void __fastcall ArgStringStringNoResultProc(void);
	void __fastcall ArgStringBooleanNoResultProc(void);
	void __fastcall ArgStringFloatNoResultProc(void);
	void __fastcall ArgStringVariantNoResultProc(void);
	void __fastcall ArgStringObjectNoResultProc(void);
	void __fastcall NoArgsResultIntegerProc(void);
	void __fastcall NoArgsResultStringProc(void);
	void __fastcall NoArgsResultBooleanProc(void);
	void __fastcall NoArgsResultFloatProc(void);
	void __fastcall NoArgsResultVariantProc(void);
	void __fastcall NoArgsResultObjectProc(void);
	void __fastcall ArgIntegerResultIntegerProc(void);
	void __fastcall ArgIntegerResultStringProc(void);
	void __fastcall ArgIntegerResultBooleanProc(void);
	void __fastcall ArgIntegerResultFloatProc(void);
	void __fastcall ArgIntegerResultVariantProc(void);
	void __fastcall ArgIntegerResultObjectProc(void);
	void __fastcall ArgStringResultIntegerProc(void);
	void __fastcall ArgStringResultStringProc(void);
	void __fastcall ArgStringResultBooleanProc(void);
	void __fastcall ArgStringResultFloatProc(void);
	void __fastcall ArgStringResultVariantProc(void);
	void __fastcall ArgStringResultObjectProc(void);
	void __fastcall ArgVariantResultIntegerProc(void);
	void __fastcall ArgVariantResultStringProc(void);
	void __fastcall ArgVariantResultBooleanProc(void);
	void __fastcall ArgVariantResultFloatProc(void);
	void __fastcall ArgVariantResultVariantProc(void);
	void __fastcall ArgVariantResultObjectProc(void);
	void __fastcall ArgObjectResultIntegerProc(void);
	void __fastcall ArgObjectResultStringProc(void);
	void __fastcall ArgObjectResultBooleanProc(void);
	void __fastcall ArgObjectResultFloatProc(void);
	void __fastcall ArgObjectResultVariantProc(void);
	void __fastcall ArgObjectResultObjectProc(void);
	__property System::AnsiString Name = {read=FName};
	__property TGenericProc Proc = {read=FProc, write=FProc};
	__property TatPascalTypeKind ResultDataType = {read=FResultDataType, nodefault};
	__property int ArgCount = {read=FArgCount, nodefault};
};

class PASCALIMPLEMENTATION TatPascalDataDef : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FName;
	TatPascalTypeKind FDataType;
	TatPascalModifier FModifier;
	
public:
	__property System::AnsiString Name = {read=FName};
	__property TatPascalTypeKind DataType = {read=FDataType, nodefault};
	__property TatPascalModifier Modifier = {read=FModifier, nodefault};
public:
	/* TCollectionItem.Create */ __fastcall virtual TatPascalDataDef(Classes::TCollection* Collection) : 
		Classes::TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TatPascalDataDef(void) { }
	
};

class DELPHICLASS TatPascalDefaultInstances;
class DELPHICLASS TatPascalDefaultInstance;
class PASCALIMPLEMENTATION TatPascalDefaultInstances : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalClasses* FClasses;
	HIDESBASE TatPascalDefaultInstance* __fastcall GetItem(int i);
	
public:
	__fastcall TatPascalDefaultInstances(TatPascalClasses* AClasses);
	HIDESBASE TatPascalDefaultInstance* __fastcall Add(System::TObject* AInstance);
	int __fastcall FindInstanceByMethodName(System::AnsiString AMethodName, TatPascalMethod* &AMethod);
		
	int __fastcall FindInstanceByPropertyName(System::AnsiString APropertyName, TatPascalProperty* &AProperty
		);
	int __fastcall IndexOf(System::AnsiString AName);
	__property TatPascalDefaultInstance* Items[int i] = {read=GetItem/*, default*/};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TatPascalDefaultInstances(void) { }
	
};

class PASCALIMPLEMENTATION TatPascalDefaultInstance : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FName;
	System::TObject* FInstance;
	TatPascalClass* FatPascalClass;
	
public:
	__property System::AnsiString Name = {read=FName};
	__property System::TObject* Instance = {read=FInstance};
	__property TatPascalClass* atPascalClass = {read=FatPascalClass};
public:
	/* TCollectionItem.Create */ __fastcall virtual TatPascalDefaultInstance(Classes::TCollection* Collection
		) : Classes::TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TatPascalDefaultInstance(void) { }
	
};

class DELPHICLASS TatPascalClassRefs;
class DELPHICLASS TatPascalClassRef;
class PASCALIMPLEMENTATION TatPascalClassRefs : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalScripter* FScripter;
	HIDESBASE TatPascalClassRef* __fastcall GetItem(int i);
	
public:
	__fastcall TatPascalClassRefs(TatPascalScripter* AScripter);
	HIDESBASE TatPascalClassRef* __fastcall Add(int AClassIndex, int AElementIndex, bool AElementIsMethod
		);
	__property TatPascalClassRef* Items[int i] = {read=GetItem/*, default*/};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TatPascalClassRefs(void) { }
	
};

class PASCALIMPLEMENTATION TatPascalClassRef : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	int FClassIndex;
	int FElementIndex;
	bool FElementIsMethod;
	
public:
	void __fastcall CheckLoaded(void);
	__property int ClassIndex = {read=FClassIndex, nodefault};
	__property int ElementIndex = {read=FElementIndex, nodefault};
	__property bool ElementIsMethod = {read=FElementIsMethod, nodefault};
public:
	/* TCollectionItem.Create */ __fastcall virtual TatPascalClassRef(Classes::TCollection* Collection)
		 : Classes::TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TatPascalClassRef(void) { }
	
};

class DELPHICLASS TatScripterLibrary;
class PASCALIMPLEMENTATION TatScripterLibrary : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TatPascalScripter* FScripter;
	
protected:
	virtual void __fastcall Init(void) = 0;
	__property TatPascalScripter* Scripter = {read=FScripter};
	
public:
	__fastcall virtual TatScripterLibrary(TatPascalScripter* AScripter);
public:
	/* TObject.Destroy */ __fastcall virtual ~TatScripterLibrary(void) { }
	
};

typedef System::TMetaClass*TatScripterLibraryClass;

class DELPHICLASS TatLibraryListItem;
class PASCALIMPLEMENTATION TatLibraryListItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::TMetaClass*FLibraryClass;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property System::TMetaClass* LibraryClass = {read=FLibraryClass, write=FLibraryClass};
public:
	/* TCollectionItem.Create */ __fastcall virtual TatLibraryListItem(Classes::TCollection* Collection
		) : Classes::TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TatLibraryListItem(void) { }
	
};

class DELPHICLASS TatLibraryList;
class PASCALIMPLEMENTATION TatLibraryList : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	HIDESBASE TatLibraryListItem* __fastcall GetItem(int Index);
	
public:
	HIDESBASE TatLibraryListItem* __fastcall Add(void);
	void __fastcall Remove(System::TMetaClass* ALibrary);
	__property TatLibraryListItem* Items[int Index] = {read=GetItem/*, default*/};
public:
	/* TCollection.Create */ __fastcall TatLibraryList(System::TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	/* TCollection.Destroy */ __fastcall virtual ~TatLibraryList(void) { }
	
};

class PASCALIMPLEMENTATION TatPascalScripter : public Atscript::TatCustomScripter 
{
	typedef Atscript::TatCustomScripter inherited;
	
private:
	TatPascalDefaultInstances* FDefaultInstances;
	TatPascalClasses* FClasses;
	Usystemlibrary::TatSystemLibrary* FSystemLibrary;
	TatPascalClassRefs* FImplicitClassRefs;
	bool FPrepareCommomClasses;
	int FForCount;
	int FCurrentFor;
	int FWhileCount;
	int FCurrentWhile;
	int FRepeatCount;
	int FCurrentRepeat;
	int FIfCount;
	int FCurrentIf;
	TLoopStatement FCurrentLoop;
	TatPascalClass* FCurrentClass;
	Classes::TList* FLibInstances;
	bool __fastcall AcceptNodeId(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeMain(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterMain(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeSubRoutine(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterSubRoutine(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeMultiAssign(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterPushOutput(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeFor(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterFor(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterForControl(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterStep(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeWhile(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterWhile(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeWhileControl(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterWhileControl(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeRepeat(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterRepeat(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeIf(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterIf(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeThen(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterThen(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeElse(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeGet(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterGet(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterBreak(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterExit(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeExpression(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterExpression(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterOperator(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterSignal(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterLabel(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterId(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterReal(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterString(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeArgList(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterArgList(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterCallCode(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterDataValCode(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterDataRefCode(Atparser::TNoTerminalNode* Node);
	void __fastcall MakeDataElementCode(Atparser::TNoTerminalNode* Node, TDataOperation operation);
	void __fastcall BeforeTry(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterTryStatements(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterTryUpshot(Atparser::TNoTerminalNode* Node);
	void __fastcall UndefinedGetterProc(void);
	void __fastcall UndefinedSetterProc(void);
	void __fastcall UndefinedMethodProc(void);
	TatPascalClass* __fastcall GetSystemLibrary(void);
	TGenericProc __fastcall RelativeMethodRef(TatPascalMethod* AMethod);
	TGenericProc __fastcall RelativeGetterRef(TatPascalProperty* AProperty);
	TGenericProc __fastcall RelativeSetterRef(TatPascalProperty* AProperty);
	void __fastcall DeleteCascadeUserProcs(TatPascalScripter* AScripter);
	void __fastcall CreateLibraries(void);
	void __fastcall FreeLibraries(void);
	
public:
	__fastcall virtual TatPascalScripter(Classes::TComponent* AOwner);
	__fastcall virtual ~TatPascalScripter(void);
	virtual void __fastcall Clear(void);
	TatPascalClass* __fastcall ClassByName(System::AnsiString AName);
	TatPascalClass* __fastcall AddClass(System::AnsiString AName, System::AnsiString AAncestorName);
	TatPascalClass* __fastcall AddDelphiClass(System::TMetaClass* AClass);
	TatPascalClass* __fastcall UsesObject(System::TObject* AObject);
	void __fastcall LoadCodeFromFile(System::AnsiString AFileName);
	void __fastcall SaveCodeToFile(System::AnsiString AFileName);
	virtual void __fastcall LoadCodeFromStream(Classes::TStream* AStream);
	virtual void __fastcall SaveCodeToStream(Classes::TStream* AStream);
	virtual void __fastcall SolveAbsoluteAddressing(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	TGenericProc __fastcall UserProc(TUserProc AProc);
	__property TatPascalDefaultInstances* DefaultInstances = {read=FDefaultInstances};
	__property TatPascalClasses* Classes = {read=FClasses};
	__property TatPascalClassRefs* ImplicitClassRefs = {read=FImplicitClassRefs};
	__property TatPascalClass* SystemLibrary = {read=GetSystemLibrary};
	__property bool PrepareCommomClasses = {read=FPrepareCommomClasses, write=FPrepareCommomClasses, nodefault
		};
	
__published:
	__property SourceCode ;
	__property Compiled ;
};

//-- var, const, procedure ---------------------------------------------------
#define MaxFunctions (Byte)(100)
#define StackSize (Word)(3000)
#define CODEFILE_VERSION (Byte)(2)
extern PACKAGE System::TObject* __fastcall VarToObject(const System::Variant &v);
extern PACKAGE double __fastcall StrVal(System::AnsiString s);
extern PACKAGE int __fastcall VarToInteger(const System::Variant &v);
extern PACKAGE int __fastcall VarToEnumInteger(const System::Variant &v, Typinfo::PPropInfo PropInfo
	);
extern PACKAGE double __fastcall VarToFloat(const System::Variant &v);
extern PACKAGE bool __fastcall VarToBoolean(const System::Variant &v);
extern PACKAGE System::AnsiString __fastcall VarContent(const System::Variant &v);
extern PACKAGE void __fastcall RegisterScripterLibrary(System::TMetaClass* ALibrary);
extern PACKAGE void __fastcall UnregisterScripterLibrary(System::TMetaClass* ALibrary);

}	/* namespace Atscript */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Atscript;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// atScript
