// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'atScript.pas' rev: 5.00

#ifndef atScriptHPP
#define atScriptHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <uSystemLibrary.hpp>	// Pascal unit
#include <TypInfo.hpp>	// Pascal unit
#include <atParser.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <ComCtrls.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Atscript
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TInstruction { inPrepare, inPushNumber, inPushVar, inPushString, inPushOutput, inDuplicate, inDuplicate2, 
	inDrop2, inSwap2, inOperNE, inOperGE, inOperLE, inOperEqual, inOperGreater, inOperLess, inOperAdd, 
	inOperSub, inOperOr, inOperMul, inOperDiv, inOperAnd, inOperExp, inOperNeg, inJumpIfZero, inJump, inStoreVar, 
	inCall, inRet, inStoreInput, inExecFun, inPushInteger, inCallProc, inTryFinally, inTryExcept };
#pragma option pop

typedef void __fastcall (__closure *TGenericProc)(void);

typedef void __fastcall (__closure *TBuiltInProc)(const Variant &Input, Variant &Output);

struct TSimplifiedCode;
typedef TSimplifiedCode *pSimplifiedCode;

struct TSimplifiedCode
{
	TInstruction OpCode;
	Byte vByte;
	Byte vUnused[6];
	int vInteger;
	AnsiString vString;
	int vDebugInfo;
	TSimplifiedCode *Next;
	TGenericProc Compute;
	union
	{
		struct 
		{
			int vInteger1;
			int vInteger2;
			
		};
		struct 
		{
			TGenericProc vProc;
			
		};
		struct 
		{
			double vDouble;
			
		};
		
	};
} ;

typedef void __fastcall (__closure *TSingleStepProc)(pSimplifiedCode p);

#pragma option push -b-
enum TStackType { stPendingOperators, stIdentifierList, stContext, stVariables };
#pragma option pop

struct TStackElement;
typedef TStackElement *pStackElement;

struct TStackElement
{
	TStackElement *Previous;
	Variant Element;
	int Index;
} ;

struct TAddress;
typedef TAddress *pAddress;

struct TAddress
{
	int Address;
	TSimplifiedCode *Code;
	TAddress *Next;
} ;

struct TLabelSpec;
typedef TLabelSpec *pLabelSpec;

struct TLabelSpec
{
	AnsiString Name;
	int Address;
	TAddress *FirstRef;
	TAddress *LastRef;
	TLabelSpec *Next;
} ;

struct TImplicitClassRef
{
	int ClassIndex;
	int ElementIndex;
	bool ElementIsMethod;
} ;

struct TCodeFileHeader
{
	char Signature[25];
	Byte Version;
	int ImplicitRefCount;
	Byte Reserved[32];
} ;

struct TInstructionDetails
{
	Byte OpCode;
	Byte vByte;
	Byte vUnused[2];
	int vInteger;
	int vDebugInfo;
	int vInteger1;
	int vInteger2;
} ;

struct TInstructionDescriptor
{
	int Size;
	TInstructionDetails Details;
} ;

#pragma option push -b-
enum TDataOperation { doRead, doWrite, doExec };
#pragma option pop

#pragma option push -b-
enum TClassReference { crNone, crGetter, crSetter, crMethod };
#pragma option pop

class DELPHICLASS EatPascalRuntime;
class PASCALIMPLEMENTATION EatPascalRuntime : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EatPascalRuntime(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EatPascalRuntime(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EatPascalRuntime(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EatPascalRuntime(int Ident, const System::TVarRec * 
		Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EatPascalRuntime(const AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EatPascalRuntime(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EatPascalRuntime(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EatPascalRuntime(System::PResStringRec ResStringRec
		, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EatPascalRuntime(void) { }
	#pragma option pop
	
};


class DELPHICLASS EatPascalFatal;
class PASCALIMPLEMENTATION EatPascalFatal : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EatPascalFatal(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EatPascalFatal(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EatPascalFatal(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EatPascalFatal(int Ident, const System::TVarRec * Args
		, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EatPascalFatal(const AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EatPascalFatal(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EatPascalFatal(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EatPascalFatal(System::PResStringRec ResStringRec
		, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EatPascalFatal(void) { }
	#pragma option pop
	
};


typedef Variant atScript__4[3000];

class DELPHICLASS TatCustomScripter;
class DELPHICLASS TScriptInfo;
class DELPHICLASS TRoutinesInfo;
class DELPHICLASS TRoutineInfo;
class PASCALIMPLEMENTATION TRoutinesInfo : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TScriptInfo* FScriptInfo;
	HIDESBASE TRoutineInfo* __fastcall GetItem(int i);
	
public:
	HIDESBASE TRoutineInfo* __fastcall Add(AnsiString AName, int ADeclarationSourcePos, int ADeclarationInstruction
		);
	int __fastcall IndexOf(AnsiString AName);
	TRoutineInfo* __fastcall RoutineByName(AnsiString AName);
	__property TRoutineInfo* Items[int i] = {read=GetItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Create */ inline __fastcall TRoutinesInfo(TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TRoutinesInfo(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TScriptInfo : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TatCustomScripter* FScripter;
	TRoutinesInfo* FRoutines;
	bool FLoaded;
	int FCodeSize;
	void __fastcall CheckLoaded(void);
	
public:
	__fastcall TScriptInfo(TatCustomScripter* AScripter);
	__fastcall virtual ~TScriptInfo(void);
	void __fastcall Clear(void);
	__property TRoutinesInfo* Routines = {read=FRoutines};
	__property int CodeSize = {read=FCodeSize, nodefault};
};


class PASCALIMPLEMENTATION TatCustomScripter : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Atparser::TatSyntaxParser* FatSyntaxParser;
	TSimplifiedCode *FFirstInstruction;
	TSimplifiedCode *FLastInstruction;
	TGenericProc FComputeProcs[34];
	TBuiltInProc FBuiltInProcs[100];
	Classes::TStringList* FBuiltInNames;
	TStackElement *FStack[4];
	int FCodeLine;
	TLabelSpec *FFirstLabelSpec;
	TLabelSpec *FLastLabelSpec;
	TInstruction FAutoRef[11];
	int FAutoRefCount;
	bool FProcrastination;
	bool FSolvedAddressing;
	bool FCompiled;
	Variant FProcStack[3000];
	int FStackTop;
	int FStackBase;
	int FInputBase;
	int FOutputBase;
	int FInputOffset;
	int FOutputOffset;
	TSimplifiedCode *FNextInstruction;
	TSimplifiedCode *FCurrentInstruction;
	AnsiString FLastExceptionMessage;
	int FLastExceptionHelpContext;
	AnsiString FLastExceptionClassName;
	TSimplifiedCode *FPrepareInstruction;
	System::TObject* FCurrentObject;
	int FCurrentInputArgBase;
	int FCurrentOutputArgIndex;
	TScriptInfo* FScriptInfo;
	Classes::TMemoryStream* FPCode;
	Classes::TStrings* FSourceCode;
	void __fastcall StackPush(TStackType StackType, const Variant &x);
	void __fastcall StackPushDelimitter(TStackType StackType);
	bool __fastcall EmptyStack(TStackType StackType);
	Variant __fastcall StackPop(TStackType StackType);
	Variant __fastcall StackView(TStackType StackType);
	int __fastcall StackIndex(TStackType StackType);
	bool __fastcall StackDelimitterFound(TStackType StackType);
	Variant __fastcall StackGetByIndex(TStackType st, int i);
	int __fastcall IndexOfStackTextValue(TStackType st, AnsiString s);
	void __fastcall ClearStacks(void);
	pLabelSpec __fastcall NewLabelSpec(AnsiString Name);
	pLabelSpec __fastcall FindLabelSpec(AnsiString name);
	void __fastcall RegisterReference(AnsiString Name);
	void __fastcall SolveReference(pLabelSpec LabelSpec);
	void __fastcall DefineReferenceAddress(AnsiString Name);
	void __fastcall SetAutomaticReferencing(const TInstruction * ilist, const int ilist_Size);
	void __fastcall ClearLabelSpecs(void);
	void __fastcall SolveUndefinedReferences(void);
	void __fastcall RegisterVariableReference(AnsiString id, int &index, AnsiString &name);
	void __fastcall AppendInstructionDouble(TInstruction i, int vl, Byte vb, double vd, AnsiString vs, 
		int ADebugInfo);
	void __fastcall AppendInstructionInteger(TInstruction i, int vl, Byte vb, int vi1, int vi2, AnsiString 
		vs, int ADebugInfo);
	void __fastcall AppendInstructionProc(TInstruction i, int vl, Byte vb, TGenericProc vp, AnsiString 
		vs, int ADebugInfo);
	int __fastcall ExecProcess(int ParamCount);
	void __fastcall _Prepare(void);
	void __fastcall _PushNumber(void);
	void __fastcall _PushVar(void);
	void __fastcall _PushString(void);
	void __fastcall _PushOutput(void);
	void __fastcall _Duplicate(void);
	void __fastcall _Duplicate2(void);
	void __fastcall _Drop2(void);
	void __fastcall _Swap2(void);
	void __fastcall _OperNE(void);
	void __fastcall _OperGE(void);
	void __fastcall _OperLE(void);
	void __fastcall _OperEqual(void);
	void __fastcall _OperGreater(void);
	void __fastcall _OperLess(void);
	void __fastcall _OperAdd(void);
	void __fastcall _OperSub(void);
	void __fastcall _OperOr(void);
	void __fastcall _OperMul(void);
	void __fastcall _OperDiv(void);
	void __fastcall _OperAnd(void);
	void __fastcall _OperExp(void);
	void __fastcall _OperNeg(void);
	void __fastcall _JumpIfZero(void);
	void __fastcall _Jump(void);
	void __fastcall _StoreVar(void);
	void __fastcall _Call(void);
	void __fastcall _Ret(void);
	void __fastcall _StoreInput(void);
	void __fastcall _ExecFun(void);
	void __fastcall _PushInteger(void);
	void __fastcall _TryFinally(void);
	void __fastcall _TryExcept(void);
	void __fastcall _CallProc(void);
	void __fastcall SetSourceCode(Classes::TStrings* value);
	AnsiString __fastcall GetStackContentAsString();
	AnsiString __fastcall ErrorComplement(int APos);
	TScriptInfo* __fastcall GetScriptInfo(void);
	void __fastcall ReadPCodeProp(Classes::TStream* Stream);
	void __fastcall WritePCodeProp(Classes::TStream* Stream);
	bool __fastcall PCodeEquals(Classes::TStream* pcode);
	void __fastcall SourceCodeChange(System::TObject* Sender);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall LoadCodeFromStream(Classes::TStream* AStream) = 0 ;
	virtual void __fastcall SaveCodeToStream(Classes::TStream* AStream) = 0 ;
	
public:
	__fastcall virtual TatCustomScripter(Classes::TComponent* AOwner);
	__fastcall virtual ~TatCustomScripter(void);
	virtual void __fastcall Clear(void);
	void __fastcall AddFunction(AnsiString Name, TBuiltInProc Address);
	virtual void __fastcall Compile(void);
	virtual Variant __fastcall Execute(const Variant &input);
	Variant __fastcall ExecuteSubroutine(AnsiString ALabel, const Variant &input);
	void __fastcall BuildSyntaxTreeView(Comctrls::TTreeView* treeview);
	void __fastcall BuildSimplifiedCodeListView(Comctrls::TListView* listview);
	Variant __fastcall GetInputArg(int AIndex);
	AnsiString __fastcall GetInputArgAsString(int AIndex);
	int __fastcall GetInputArgAsInteger(int AIndex);
	bool __fastcall GetInputArgAsBoolean(int AIndex);
	double __fastcall GetInputArgAsFloat(int AIndex);
	System::TDateTime __fastcall GetInputArgAsDateTime(int AIndex);
	void __fastcall ReturnOutputArg(const Variant &AValue);
	void __fastcall GetRowColFromSource(int APos, int &row, int &col);
	virtual void __fastcall SolveAbsoluteAddressing(void) = 0 ;
	__property Classes::TStrings* SourceCode = {read=FSourceCode, write=SetSourceCode};
	__property AnsiString LastExceptionMessage = {read=FLastExceptionMessage};
	__property int LastExceptionHelpContext = {read=FLastExceptionHelpContext, nodefault};
	__property AnsiString LastExceptionClassName = {read=FLastExceptionClassName};
	__property TScriptInfo* ScriptInfo = {read=GetScriptInfo};
	__property System::TObject* CurrentObject = {read=FCurrentObject};
	__property bool Compiled = {read=FCompiled, write=FCompiled, nodefault};
	__property Classes::TMemoryStream* PCode = {read=FPCode, write=FPCode};
};


class DELPHICLASS TVariablesInfo;
class DELPHICLASS TVariableInfo;
class PASCALIMPLEMENTATION TVariablesInfo : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TRoutineInfo* FRoutine;
	HIDESBASE TVariableInfo* __fastcall GetItem(int i);
	
public:
	HIDESBASE TVariableInfo* __fastcall Add(void);
	int __fastcall IndexOf(AnsiString AName);
	TVariableInfo* __fastcall VariableByName(AnsiString AName);
	__property TVariableInfo* Items[int i] = {read=GetItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Create */ inline __fastcall TVariablesInfo(TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TVariablesInfo(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TRoutineInfo : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TVariablesInfo* FVariables;
	AnsiString FName;
	int FDeclarationSourcePos;
	int FDeclarationInstruction;
	
public:
	__fastcall virtual TRoutineInfo(Classes::TCollection* ACollection);
	__fastcall virtual ~TRoutineInfo(void);
	__property AnsiString Name = {read=FName};
	__property int DeclarationSourcePos = {read=FDeclarationSourcePos, nodefault};
	__property int DeclarationInstruction = {read=FDeclarationInstruction, nodefault};
	__property TVariablesInfo* Variables = {read=FVariables};
};


class PASCALIMPLEMENTATION TVariableInfo : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	AnsiString FName;
	int FDeclarationSourcePos;
	int FDeclarationInstruction;
	int FReadCount;
	Variant __fastcall GetValue();
	void __fastcall SetValue(const Variant &AValue);
	TatCustomScripter* __fastcall Scripter(void);
	TRoutineInfo* __fastcall Routine(void);
	
public:
	bool __fastcall Internal(void);
	__property AnsiString Name = {read=FName};
	__property int ReadCount = {read=FReadCount, nodefault};
	__property Variant Value = {read=GetValue, write=SetValue};
	__property int DeclarationSourcePos = {read=FDeclarationSourcePos, nodefault};
	__property int DeclarationInstruction = {read=FDeclarationInstruction, nodefault};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Create */ inline __fastcall virtual TVariableInfo(Classes::TCollection* Collection
		) : Classes::TCollectionItem(Collection) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TVariableInfo(void) { }
	#pragma option pop
	
};


class DELPHICLASS TatPascalScripter;
typedef void __fastcall (__closure *TUserProc)(TatPascalScripter* AScripter);

#pragma option push -b-
enum TatPascalTypeKind { tkNone, tkInteger, tkChar, tkEnumeration, tkFloat, tkString, tkSet, tkClass, 
	tkMethod, tkWChar, tkLString, tkWString, tkVariant, tkArray, tkRecord, tkInterface };
#pragma option pop

#pragma option push -b-
enum TatPascalModifier { moConst, moVar };
#pragma option pop

typedef Set<TatPascalModifier, moConst, moVar>  TatPascalModifiers;

#pragma option push -b-
enum TLoopStatement { lsNone, lsFor, lsWhile, lsRepeat };
#pragma option pop

typedef void __fastcall (__closure *TNoArgsNoResultProc)(void);

typedef void __fastcall (__closure *TArgIntegerNoResultProc)(int AInteger);

typedef void __fastcall (__closure *TArgStringNoResultProc)(AnsiString AString);

typedef void __fastcall (__closure *TArgBooleanNoResultProc)(bool ABoolean);

typedef void __fastcall (__closure *TArgFloatNoResultProc)(double AFloat);

typedef void __fastcall (__closure *TArgVariantNoResultProc)(const Variant &AVariant);

typedef void __fastcall (__closure *TArgObjectNoResultProc)(System::TObject* AObject);

typedef void __fastcall (__closure *TArgIntegerIntegerNoResultProc)(int i, int AInteger1);

typedef void __fastcall (__closure *TArgIntegerStringNoResultProc)(int i, AnsiString AString);

typedef void __fastcall (__closure *TArgIntegerBooleanNoResultProc)(int i, bool ABoolean);

typedef void __fastcall (__closure *TArgIntegerFloatNoResultProc)(int i, double AFloat);

typedef void __fastcall (__closure *TArgIntegerVariantNoResultProc)(int i, const Variant &AVariant);
	

typedef void __fastcall (__closure *TArgIntegerObjectNoResultProc)(int i, System::TObject* AObject);
	

typedef void __fastcall (__closure *TArgStringIntegerNoResultProc)(AnsiString s, int AInteger);

typedef void __fastcall (__closure *TArgStringStringNoResultProc)(AnsiString s, AnsiString AString);
	

typedef void __fastcall (__closure *TArgStringBooleanNoResultProc)(AnsiString s, bool ABoolean);

typedef void __fastcall (__closure *TArgStringFloatNoResultProc)(AnsiString s, double AFloat);

typedef void __fastcall (__closure *TArgStringVariantNoResultProc)(AnsiString s, const Variant &AVariant
	);

typedef void __fastcall (__closure *TArgStringObjectNoResultProc)(AnsiString s, System::TObject* AObject
	);

typedef int __fastcall (__closure *TNoArgsResultIntegerProc)(void);

typedef AnsiString __fastcall (__closure *TNoArgsResultStringProc)(void);

typedef bool __fastcall (__closure *TNoArgsResultBooleanProc)(void);

typedef double __fastcall (__closure *TNoArgsResultFloatProc)(void);

typedef Variant __fastcall (__closure *TNoArgsResultVariantProc)(void);

typedef System::TObject* __fastcall (__closure *TNoArgsResultObjectProc)(void);

typedef int __fastcall (__closure *TArgIntegerResultIntegerProc)(int i);

typedef AnsiString __fastcall (__closure *TArgIntegerResultStringProc)(int i);

typedef bool __fastcall (__closure *TArgIntegerResultBooleanProc)(int i);

typedef double __fastcall (__closure *TArgIntegerResultFloatProc)(int i);

typedef Variant __fastcall (__closure *TArgIntegerResultVariantProc)(int i);

typedef System::TObject* __fastcall (__closure *TArgIntegerResultObjectProc)(int i);

typedef int __fastcall (__closure *TArgStringResultIntegerProc)(AnsiString s);

typedef AnsiString __fastcall (__closure *TArgStringResultStringProc)(AnsiString s);

typedef bool __fastcall (__closure *TArgStringResultBooleanProc)(AnsiString s);

typedef double __fastcall (__closure *TArgStringResultFloatProc)(AnsiString s);

typedef Variant __fastcall (__closure *TArgStringResultVariantProc)(AnsiString s);

typedef System::TObject* __fastcall (__closure *TArgStringResultObjectProc)(AnsiString s);

typedef int __fastcall (__closure *TArgVariantResultIntegerProc)(const Variant &v);

typedef AnsiString __fastcall (__closure *TArgVariantResultStringProc)(const Variant &v);

typedef bool __fastcall (__closure *TArgVariantResultBooleanProc)(const Variant &v);

typedef double __fastcall (__closure *TArgVariantResultFloatProc)(const Variant &v);

typedef Variant __fastcall (__closure *TArgVariantResultVariantProc)(const Variant &v);

typedef System::TObject* __fastcall (__closure *TArgVariantResultObjectProc)(const Variant &v);

typedef int __fastcall (__closure *TArgObjectResultIntegerProc)(System::TObject* o);

typedef AnsiString __fastcall (__closure *TArgObjectResultStringProc)(System::TObject* o);

typedef bool __fastcall (__closure *TArgObjectResultBooleanProc)(System::TObject* o);

typedef double __fastcall (__closure *TArgObjectResultFloatProc)(System::TObject* o);

typedef Variant __fastcall (__closure *TArgObjectResultVariantProc)(System::TObject* o);

typedef System::TObject* __fastcall (__closure *TArgObjectResultObjectProc)(System::TObject* o);

class DELPHICLASS TatPascalClasses;
class DELPHICLASS TatPascalClass;
class PASCALIMPLEMENTATION TatPascalClasses : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalScripter* FScripter;
	HIDESBASE TatPascalClass* __fastcall GetItem(int i);
	
protected:
	TatPascalClass* __fastcall AddClassInfo(TMetaClass* AClass);
	TatPascalClass* __fastcall CheckLoaded(TMetaClass* AClass);
	bool __fastcall TestCheckLoaded(TMetaClass* AClass, TatPascalClass* &ACurrentClass);
	
public:
	__fastcall TatPascalClasses(TatPascalScripter* AScripter);
	HIDESBASE TatPascalClass* __fastcall Add(AnsiString AName, AnsiString AAncestorName);
	int __fastcall IndexOf(AnsiString AName);
	__property TatPascalClass* Items[int i] = {read=GetItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TatPascalClasses(void) { }
	#pragma option pop
	
};


class DELPHICLASS TatPascalProperties;
class DELPHICLASS TatPascalProperty;
class PASCALIMPLEMENTATION TatPascalProperties : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalClass* FClass;
	HIDESBASE TatPascalProperty* __fastcall GetItem(int i);
	__fastcall TatPascalProperties(TatPascalClass* AClass);
	__property TatPascalProperty* Items[int i] = {read=GetItem/*, default*/};
	TatPascalProperty* __fastcall AddByRTTI(Typinfo::PPropInfo APropInfo);
	int __fastcall IndexOf(AnsiString AName);
	TatPascalProperty* __fastcall PropertyByName(AnsiString AName);
public:
	#pragma option push -w-inl
	/* TCollection.Create */ inline __fastcall TatPascalProperties(TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TatPascalProperties(void) { }
	#pragma option pop
	
};


class DELPHICLASS TatPascalMethods;
class DELPHICLASS TatPascalMethod;
class PASCALIMPLEMENTATION TatPascalMethods : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalClass* FClass;
	HIDESBASE TatPascalMethod* __fastcall GetItem(int i);
	
protected:
	__fastcall TatPascalMethods(TatPascalClass* AClass);
	__property TatPascalMethod* Items[int i] = {read=GetItem/*, default*/};
	int __fastcall IndexOf(AnsiString AName);
	TatPascalMethod* __fastcall MethodByName(AnsiString AName);
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TatPascalMethods(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TatPascalClass : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	AnsiString FName;
	TatPascalProperties* FProperties;
	TatPascalMethods* FMethods;
	TMetaClass*FClassType;
	AnsiString FAncestorName;
	TatPascalClass* FAncestor;
	Classes::TList* FDescendants;
	void __fastcall Inherits(AnsiString AAncestorName);
	TatPascalMethod* __fastcall SetProc(AnsiString AName, void * ACode, int AArgCount, TatPascalTypeKind 
		AResultDataType, TGenericProc AProc, TMetaClass* AResultClass);
	void __fastcall TCollectionGetCountProc(void);
	void __fastcall TCollectionItemGetIndexProc(void);
	void __fastcall TCollectionItemSetIndexProc(void);
	void __fastcall RemoveDescendant(TatPascalClass* ADescendant);
	void __fastcall InsertDescendant(TatPascalClass* ADescendant);
	void __fastcall NotifyDescendants(void);
	void __fastcall AncestorDestroyed(void);
	
public:
	__fastcall virtual TatPascalClass(Classes::TCollection* ACollection);
	__fastcall virtual ~TatPascalClass(void);
	TatPascalMethod* __fastcall AddProc(AnsiString AName, void * ACode, int AArgCount, TatPascalTypeKind 
		AResultDataType, TGenericProc AProc, TMetaClass* AResultClass);
	void __fastcall AddObject(AnsiString AName, System::TObject* AObject);
	void __fastcall AddConstant(AnsiString AName, const Variant &AValue);
	void __fastcall AddVariable(AnsiString AName, void *AVar);
	void __fastcall PrepareVCLClass(void);
	TatPascalProperty* __fastcall AddProp(AnsiString AName, TatPascalTypeKind ADataType, TGenericProc AGetter
		, TGenericProc ASetter, TMetaClass* APropertyClass);
	TatPascalProperty* __fastcall SetProp(AnsiString AName, TatPascalTypeKind ADataType, TGenericProc AGetter
		, TGenericProc ASetter, TMetaClass* APropertyClass);
	void __fastcall AddIntegerProp(AnsiString AName, TGenericProc AGetter, TGenericProc ASetter);
	void __fastcall AddStringProp(AnsiString AName, TGenericProc AGetter, TGenericProc ASetter);
	void __fastcall AddBooleanProp(AnsiString AName, TGenericProc AGetter, TGenericProc ASetter);
	void __fastcall AddFloatProp(AnsiString AName, TGenericProc AGetter, TGenericProc ASetter);
	void __fastcall AddVariantProp(AnsiString AName, TGenericProc AGetter, TGenericProc ASetter);
	void __fastcall AddObjectProp(AnsiString AName, TGenericProc AGetter, TGenericProc ASetter, TMetaClass* 
		APropertyClass);
	void __fastcall AddDelphiObjectProp(AnsiString AName, System::TObject* AObject);
	TatPascalMethod* __fastcall AddMethod(AnsiString AName, int AArgCount, TatPascalTypeKind AResultDataType
		, TMetaClass* AResultClass, TGenericProc AProc);
	void __fastcall AddNoArgsNoResultProc(AnsiString AName, TNoArgsNoResultProc AMethod);
	void __fastcall AddArgIntegerNoResultProc(AnsiString AName, TArgIntegerNoResultProc AMethod);
	void __fastcall AddArgStringNoResultProc(AnsiString AName, TArgStringNoResultProc AMethod);
	void __fastcall AddArgBooleanNoResultProc(AnsiString AName, TArgBooleanNoResultProc AMethod);
	void __fastcall AddArgFloatNoResultProc(AnsiString AName, TArgFloatNoResultProc AMethod);
	void __fastcall AddArgVariantNoResultProc(AnsiString AName, TArgVariantNoResultProc AMethod);
	void __fastcall AddArgObjectNoResultProc(AnsiString AName, TArgObjectNoResultProc AMethod);
	void __fastcall AddArgIntegerIntegerNoResultProc(AnsiString AName, TArgIntegerIntegerNoResultProc AMethod
		);
	void __fastcall AddArgIntegerStringNoResultProc(AnsiString AName, TArgIntegerStringNoResultProc AMethod
		);
	void __fastcall AddArgIntegerBooleanNoResultProc(AnsiString AName, TArgIntegerBooleanNoResultProc AMethod
		);
	void __fastcall AddArgIntegerFloatNoResultProc(AnsiString AName, TArgIntegerFloatNoResultProc AMethod
		);
	void __fastcall AddArgIntegerVariantNoResultProc(AnsiString AName, TArgIntegerVariantNoResultProc AMethod
		);
	void __fastcall AddArgIntegerObjectNoResultProc(AnsiString AName, TArgIntegerObjectNoResultProc AMethod
		);
	void __fastcall AddArgStringIntegerNoResultProc(AnsiString AName, TArgStringIntegerNoResultProc AMethod
		);
	void __fastcall AddArgStringStringNoResultProc(AnsiString AName, TArgStringStringNoResultProc AMethod
		);
	void __fastcall AddArgStringBooleanNoResultProc(AnsiString AName, TArgStringBooleanNoResultProc AMethod
		);
	void __fastcall AddArgStringFloatNoResultProc(AnsiString AName, TArgStringFloatNoResultProc AMethod
		);
	void __fastcall AddArgStringVariantNoResultProc(AnsiString AName, TArgStringVariantNoResultProc AMethod
		);
	void __fastcall AddArgStringObjectNoResultProc(AnsiString AName, TArgStringObjectNoResultProc AMethod
		);
	void __fastcall AddNoArgsResultIntegerProc(AnsiString AName, TNoArgsResultIntegerProc AMethod);
	void __fastcall AddNoArgsResultStringProc(AnsiString AName, TNoArgsResultStringProc AMethod);
	void __fastcall AddNoArgsResultBooleanProc(AnsiString AName, TNoArgsResultBooleanProc AMethod);
	void __fastcall AddNoArgsResultFloatProc(AnsiString AName, TNoArgsResultFloatProc AMethod);
	void __fastcall AddNoArgsResultVariantProc(AnsiString AName, TNoArgsResultVariantProc AMethod);
	void __fastcall AddNoArgsResultObjectProc(AnsiString AName, TNoArgsResultObjectProc AMethod, TMetaClass* 
		AResultClass);
	void __fastcall AddArgIntegerResultIntegerProc(AnsiString AName, TArgIntegerResultIntegerProc AMethod
		);
	void __fastcall AddArgIntegerResultStringProc(AnsiString AName, TArgIntegerResultStringProc AMethod
		);
	void __fastcall AddArgIntegerResultBooleanProc(AnsiString AName, TArgIntegerResultBooleanProc AMethod
		);
	void __fastcall AddArgIntegerResultFloatProc(AnsiString AName, TArgIntegerResultFloatProc AMethod);
		
	void __fastcall AddArgIntegerResultVariantProc(AnsiString AName, TArgIntegerResultVariantProc AMethod
		);
	void __fastcall AddArgIntegerResultObjectProc(AnsiString AName, TArgIntegerResultObjectProc AMethod
		, TMetaClass* AResultClass);
	void __fastcall AddArgStringResultIntegerProc(AnsiString AName, TArgStringResultIntegerProc AMethod
		);
	void __fastcall AddArgStringResultStringProc(AnsiString AName, TArgStringResultStringProc AMethod);
		
	void __fastcall AddArgStringResultBooleanProc(AnsiString AName, TArgStringResultBooleanProc AMethod
		);
	void __fastcall AddArgStringResultFloatProc(AnsiString AName, TArgStringResultFloatProc AMethod);
	void __fastcall AddArgStringResultVariantProc(AnsiString AName, TArgStringResultVariantProc AMethod
		);
	void __fastcall AddArgStringResultObjectProc(AnsiString AName, TArgStringResultObjectProc AMethod, 
		TMetaClass* AResultClass);
	void __fastcall AddArgVariantResultIntegerProc(AnsiString AName, TArgVariantResultIntegerProc AMethod
		);
	void __fastcall AddArgVariantResultStringProc(AnsiString AName, TArgVariantResultStringProc AMethod
		);
	void __fastcall AddArgVariantResultBooleanProc(AnsiString AName, TArgVariantResultBooleanProc AMethod
		);
	void __fastcall AddArgVariantResultFloatProc(AnsiString AName, TArgVariantResultFloatProc AMethod);
		
	void __fastcall AddArgVariantResultVariantProc(AnsiString AName, TArgVariantResultVariantProc AMethod
		);
	void __fastcall AddArgVariantResultObjectProc(AnsiString AName, TArgVariantResultObjectProc AMethod
		, TMetaClass* AResultClass);
	void __fastcall AddArgObjectResultIntegerProc(AnsiString AName, TArgObjectResultIntegerProc AMethod
		);
	void __fastcall AddArgObjectResultStringProc(AnsiString AName, TArgObjectResultStringProc AMethod);
		
	void __fastcall AddArgObjectResultBooleanProc(AnsiString AName, TArgObjectResultBooleanProc AMethod
		);
	void __fastcall AddArgObjectResultFloatProc(AnsiString AName, TArgObjectResultFloatProc AMethod);
	void __fastcall AddArgObjectResultVariantProc(AnsiString AName, TArgObjectResultVariantProc AMethod
		);
	void __fastcall AddArgObjectResultObjectProc(AnsiString AName, TArgObjectResultObjectProc AMethod, 
		TMetaClass* AResultClass);
	__property AnsiString Name = {read=FName};
	__property TatPascalProperties* Properties = {read=FProperties};
	__property TatPascalMethods* Methods = {read=FMethods};
	__property AnsiString AncestorName = {read=FAncestorName};
};


class PASCALIMPLEMENTATION TatPascalProperty : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TatPascalScripter* FScripter;
	AnsiString FName;
	TatPascalTypeKind FDataType;
	TGenericProc FGetter;
	TGenericProc FSetter;
	TMetaClass*FPropertyClass;
	Typinfo::TPropInfo *FPropInfo;
	Variant FValue;
	void __fastcall RTTIGetterProc(void);
	void __fastcall RTTISetterProc(void);
	void __fastcall GetDelphiObjectPropProc(void);
	void __fastcall GetVariantPropProc(void);
	void __fastcall GetVariablePropProc(void);
	void __fastcall SetVariablePropProc(void);
	
public:
	__fastcall virtual TatPascalProperty(Classes::TCollection* ACollection);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall UpdateObjectInfo(TatPascalClass* &ACurrentClass);
	__property AnsiString Name = {read=FName};
	__property TGenericProc Getter = {read=FGetter, write=FGetter};
	__property TGenericProc Setter = {read=FSetter, write=FSetter};
	__property TatPascalTypeKind DataType = {read=FDataType, nodefault};
	__property Variant Value = {read=FValue, write=FValue};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TatPascalProperty(void) { }
	#pragma option pop
	
};


class DELPHICLASS TatPascalDataDefs;
class DELPHICLASS TatPascalDataDef;
class PASCALIMPLEMENTATION TatPascalDataDefs : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	HIDESBASE TatPascalDataDef* __fastcall GetItem(int i);
	
public:
	__fastcall TatPascalDataDefs(TatPascalClass* AClass);
	__property TatPascalDataDef* Items[int i] = {read=GetItem/*, default*/};
	HIDESBASE TatPascalDataDef* __fastcall Add(AnsiString AName, TatPascalTypeKind ADataType, TatPascalModifier 
		AModifier);
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TatPascalDataDefs(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TatPascalMethod : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TatPascalScripter* FScripter;
	AnsiString FName;
	TGenericProc FProc;
	TatPascalTypeKind FResultDataType;
	int FArgCount;
	void *FCode;
	TMetaClass*FResultClass;
	TatPascalDataDefs* FArgumentDefs;
	
public:
	__fastcall virtual TatPascalMethod(Classes::TCollection* ACollection);
	__fastcall virtual ~TatPascalMethod(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall UpdateObjectInfo(TatPascalClass* &ACurrentClass);
	void __fastcall NoArgsNoResultProc(void);
	void __fastcall ArgIntegerNoResultProc(void);
	void __fastcall ArgStringNoResultProc(void);
	void __fastcall ArgBooleanNoResultProc(void);
	void __fastcall ArgFloatNoResultProc(void);
	void __fastcall ArgVariantNoResultProc(void);
	void __fastcall ArgObjectNoResultProc(void);
	void __fastcall ArgIntegerIntegerNoResultProc(void);
	void __fastcall ArgIntegerStringNoResultProc(void);
	void __fastcall ArgIntegerBooleanNoResultProc(void);
	void __fastcall ArgIntegerFloatNoResultProc(void);
	void __fastcall ArgIntegerVariantNoResultProc(void);
	void __fastcall ArgIntegerObjectNoResultProc(void);
	void __fastcall ArgStringIntegerNoResultProc(void);
	void __fastcall ArgStringStringNoResultProc(void);
	void __fastcall ArgStringBooleanNoResultProc(void);
	void __fastcall ArgStringFloatNoResultProc(void);
	void __fastcall ArgStringVariantNoResultProc(void);
	void __fastcall ArgStringObjectNoResultProc(void);
	void __fastcall NoArgsResultIntegerProc(void);
	void __fastcall NoArgsResultStringProc(void);
	void __fastcall NoArgsResultBooleanProc(void);
	void __fastcall NoArgsResultFloatProc(void);
	void __fastcall NoArgsResultVariantProc(void);
	void __fastcall NoArgsResultObjectProc(void);
	void __fastcall ArgIntegerResultIntegerProc(void);
	void __fastcall ArgIntegerResultStringProc(void);
	void __fastcall ArgIntegerResultBooleanProc(void);
	void __fastcall ArgIntegerResultFloatProc(void);
	void __fastcall ArgIntegerResultVariantProc(void);
	void __fastcall ArgIntegerResultObjectProc(void);
	void __fastcall ArgStringResultIntegerProc(void);
	void __fastcall ArgStringResultStringProc(void);
	void __fastcall ArgStringResultBooleanProc(void);
	void __fastcall ArgStringResultFloatProc(void);
	void __fastcall ArgStringResultVariantProc(void);
	void __fastcall ArgStringResultObjectProc(void);
	void __fastcall ArgVariantResultIntegerProc(void);
	void __fastcall ArgVariantResultStringProc(void);
	void __fastcall ArgVariantResultBooleanProc(void);
	void __fastcall ArgVariantResultFloatProc(void);
	void __fastcall ArgVariantResultVariantProc(void);
	void __fastcall ArgVariantResultObjectProc(void);
	void __fastcall ArgObjectResultIntegerProc(void);
	void __fastcall ArgObjectResultStringProc(void);
	void __fastcall ArgObjectResultBooleanProc(void);
	void __fastcall ArgObjectResultFloatProc(void);
	void __fastcall ArgObjectResultVariantProc(void);
	void __fastcall ArgObjectResultObjectProc(void);
	__property AnsiString Name = {read=FName};
	__property TGenericProc Proc = {read=FProc, write=FProc};
	__property TatPascalTypeKind ResultDataType = {read=FResultDataType, nodefault};
	__property int ArgCount = {read=FArgCount, nodefault};
};


class PASCALIMPLEMENTATION TatPascalDataDef : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	AnsiString FName;
	TatPascalTypeKind FDataType;
	TatPascalModifier FModifier;
	
public:
	__property AnsiString Name = {read=FName};
	__property TatPascalTypeKind DataType = {read=FDataType, nodefault};
	__property TatPascalModifier Modifier = {read=FModifier, nodefault};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Create */ inline __fastcall virtual TatPascalDataDef(Classes::TCollection* Collection
		) : Classes::TCollectionItem(Collection) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TatPascalDataDef(void) { }
	#pragma option pop
	
};


class DELPHICLASS TatPascalDefaultInstances;
class DELPHICLASS TatPascalDefaultInstance;
class PASCALIMPLEMENTATION TatPascalDefaultInstances : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalClasses* FClasses;
	HIDESBASE TatPascalDefaultInstance* __fastcall GetItem(int i);
	
public:
	__fastcall TatPascalDefaultInstances(TatPascalClasses* AClasses);
	HIDESBASE TatPascalDefaultInstance* __fastcall Add(System::TObject* AInstance);
	int __fastcall FindInstanceByMethodName(AnsiString AMethodName, TatPascalMethod* &AMethod);
	int __fastcall FindInstanceByPropertyName(AnsiString APropertyName, TatPascalProperty* &AProperty);
		
	int __fastcall IndexOf(AnsiString AName);
	__property TatPascalDefaultInstance* Items[int i] = {read=GetItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TatPascalDefaultInstances(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TatPascalDefaultInstance : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	AnsiString FName;
	System::TObject* FInstance;
	TatPascalClass* FatPascalClass;
	
public:
	__property AnsiString Name = {read=FName};
	__property System::TObject* Instance = {read=FInstance};
	__property TatPascalClass* atPascalClass = {read=FatPascalClass};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Create */ inline __fastcall virtual TatPascalDefaultInstance(Classes::TCollection* 
		Collection) : Classes::TCollectionItem(Collection) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TatPascalDefaultInstance(void) { }
	#pragma option pop
	
};


class DELPHICLASS TatPascalClassRefs;
class DELPHICLASS TatPascalClassRef;
class PASCALIMPLEMENTATION TatPascalClassRefs : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TatPascalScripter* FScripter;
	HIDESBASE TatPascalClassRef* __fastcall GetItem(int i);
	
public:
	__fastcall TatPascalClassRefs(TatPascalScripter* AScripter);
	HIDESBASE TatPascalClassRef* __fastcall Add(int AClassIndex, int AElementIndex, bool AElementIsMethod
		);
	__property TatPascalClassRef* Items[int i] = {read=GetItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TatPascalClassRefs(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TatPascalClassRef : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	int FClassIndex;
	int FElementIndex;
	bool FElementIsMethod;
	
public:
	void __fastcall CheckLoaded(void);
	__property int ClassIndex = {read=FClassIndex, nodefault};
	__property int ElementIndex = {read=FElementIndex, nodefault};
	__property bool ElementIsMethod = {read=FElementIsMethod, nodefault};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Create */ inline __fastcall virtual TatPascalClassRef(Classes::TCollection* Collection
		) : Classes::TCollectionItem(Collection) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TatPascalClassRef(void) { }
	#pragma option pop
	
};


class DELPHICLASS TatScripterLibrary;
class PASCALIMPLEMENTATION TatScripterLibrary : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TatPascalScripter* FScripter;
	
protected:
	virtual void __fastcall Init(void) = 0 ;
	__property TatPascalScripter* Scripter = {read=FScripter};
	
public:
	__fastcall virtual TatScripterLibrary(TatPascalScripter* AScripter);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TatScripterLibrary(void) { }
	#pragma option pop
	
};


typedef TMetaClass*TatScripterLibraryClass;

class DELPHICLASS TatLibraryListItem;
class PASCALIMPLEMENTATION TatLibraryListItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TMetaClass*FLibraryClass;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property TMetaClass* LibraryClass = {read=FLibraryClass, write=FLibraryClass};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Create */ inline __fastcall virtual TatLibraryListItem(Classes::TCollection* Collection
		) : Classes::TCollectionItem(Collection) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TatLibraryListItem(void) { }
	#pragma option pop
	
};


class DELPHICLASS TatLibraryList;
class PASCALIMPLEMENTATION TatLibraryList : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	HIDESBASE TatLibraryListItem* __fastcall GetItem(int Index);
	
public:
	HIDESBASE TatLibraryListItem* __fastcall Add(void);
	void __fastcall Remove(TMetaClass* ALibrary);
	__property TatLibraryListItem* Items[int Index] = {read=GetItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Create */ inline __fastcall TatLibraryList(TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TatLibraryList(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TatPascalScripter : public TatCustomScripter 
{
	typedef TatCustomScripter inherited;
	
private:
	TatPascalDefaultInstances* FDefaultInstances;
	TatPascalClasses* FClasses;
	Usystemlibrary::TatSystemLibrary* FSystemLibrary;
	TatPascalClassRefs* FImplicitClassRefs;
	bool FPrepareCommomClasses;
	int FForCount;
	int FCurrentFor;
	int FWhileCount;
	int FCurrentWhile;
	int FRepeatCount;
	int FCurrentRepeat;
	int FIfCount;
	int FCurrentIf;
	TLoopStatement FCurrentLoop;
	TatPascalClass* FCurrentClass;
	Classes::TList* FLibInstances;
	bool __fastcall AcceptNodeId(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeMain(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterMain(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeSubRoutine(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterSubRoutine(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeMultiAssign(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterPushOutput(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeFor(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterFor(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterForControl(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterStep(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeWhile(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterWhile(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeWhileControl(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterWhileControl(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeRepeat(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterRepeat(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeIf(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterIf(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeThen(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterThen(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeElse(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeGet(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterGet(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterBreak(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterExit(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeExpression(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterExpression(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterOperator(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterSignal(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterLabel(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterId(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterReal(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterString(Atparser::TNoTerminalNode* Node);
	void __fastcall BeforeArgList(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterArgList(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterCallCode(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterDataValCode(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterDataRefCode(Atparser::TNoTerminalNode* Node);
	void __fastcall MakeDataElementCode(Atparser::TNoTerminalNode* Node, TDataOperation operation);
	void __fastcall BeforeTry(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterTryStatements(Atparser::TNoTerminalNode* Node);
	void __fastcall AfterTryUpshot(Atparser::TNoTerminalNode* Node);
	void __fastcall UndefinedGetterProc(void);
	void __fastcall UndefinedSetterProc(void);
	void __fastcall UndefinedMethodProc(void);
	TatPascalClass* __fastcall GetSystemLibrary(void);
	TGenericProc __fastcall RelativeMethodRef(TatPascalMethod* AMethod);
	TGenericProc __fastcall RelativeGetterRef(TatPascalProperty* AProperty);
	TGenericProc __fastcall RelativeSetterRef(TatPascalProperty* AProperty);
	void __fastcall DeleteCascadeUserProcs(TatPascalScripter* AScripter);
	void __fastcall CreateLibraries(void);
	void __fastcall FreeLibraries(void);
	
public:
	__fastcall virtual TatPascalScripter(Classes::TComponent* AOwner);
	__fastcall virtual ~TatPascalScripter(void);
	virtual void __fastcall Clear(void);
	TatPascalClass* __fastcall ClassByName(AnsiString AName);
	TatPascalClass* __fastcall AddClass(AnsiString AName, AnsiString AAncestorName);
	TatPascalClass* __fastcall AddDelphiClass(TMetaClass* AClass);
	TatPascalClass* __fastcall UsesObject(System::TObject* AObject);
	void __fastcall LoadCodeFromFile(AnsiString AFileName);
	void __fastcall SaveCodeToFile(AnsiString AFileName);
	virtual void __fastcall LoadCodeFromStream(Classes::TStream* AStream);
	virtual void __fastcall SaveCodeToStream(Classes::TStream* AStream);
	virtual void __fastcall SolveAbsoluteAddressing(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	TGenericProc __fastcall UserProc(TUserProc AProc);
	__property TatPascalDefaultInstances* DefaultInstances = {read=FDefaultInstances};
	__property TatPascalClasses* Classes = {read=FClasses};
	__property TatPascalClassRefs* ImplicitClassRefs = {read=FImplicitClassRefs};
	__property TatPascalClass* SystemLibrary = {read=GetSystemLibrary};
	__property bool PrepareCommomClasses = {read=FPrepareCommomClasses, write=FPrepareCommomClasses, nodefault
		};
	
__published:
	__property SourceCode ;
	__property Compiled ;
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint MaxFunctions = 0x64;
static const Word StackSize = 0xbb8;
static const Shortint CODEFILE_VERSION = 0x2;
extern PACKAGE System::TObject* __fastcall VarToObject(const Variant &v);
extern PACKAGE double __fastcall StrVal(AnsiString s);
extern PACKAGE int __fastcall VarToInteger(const Variant &v);
extern PACKAGE int __fastcall VarToEnumInteger(const Variant &v, Typinfo::PPropInfo PropInfo);
extern PACKAGE double __fastcall VarToFloat(const Variant &v);
extern PACKAGE bool __fastcall VarToBoolean(const Variant &v);
extern PACKAGE AnsiString __fastcall VarContent(const Variant &v);
extern PACKAGE void __fastcall RegisterScripterLibrary(TMetaClass* ALibrary);
extern PACKAGE void __fastcall UnregisterScripterLibrary(TMetaClass* ALibrary);

}	/* namespace Atscript */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Atscript;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// atScript
